package com.huigou.topsun.proofing.controller;

import com.huigou.topsun.proofing.application.ProofingApplyApplication;
import com.huigou.topsun.proofing.domain.model.ProofingApply;
import com.huigou.topsun.proofing.domain.vo.BomVo;
import com.huigou.topsun.proofing.service.BomService;
import com.huigou.uasp.annotation.ControllerMapping;
import com.huigou.uasp.client.CommonController;
import com.huigou.uasp.log.annotation.LogInfo;
import com.huigou.uasp.log.domain.model.LogType;
import com.huigou.uasp.log.domain.model.OperationType;
import com.huigou.util.SDO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Controller
@ControllerMapping("/proofingApply")
public class ProofingApplyController extends CommonController {
    protected String getPagePath() {
        return "/biz/topsun/proofing/";
    }


    @Autowired
    private BomService bomService;
    @Autowired
    ProofingApplyApplication proofingApplyApplication;

    /**
     * 打样表单页
     * @return
     */
    public String forwardProofingApply(){
        this.putAttribute("processDefinitionKey",proofingApplyApplication .PROCESS_DEFINITION_KEY);
        String applicationNo="测试单号";
        this.putAttribute("procUnitId", "Apply");
       this.putAttribute("proofingApplyNo",applicationNo);
        return forward("proofingApply");
    }

    public String forwardAddBom(){
        //如果有id的话就带参数过去
        SDO sdo = this.getSDO();
        String id = sdo.getId();
        List<BomVo> bom = bomService.getBomVoByProductId(id);
        return forward("BomDetail",bom);
    }

    public String addProofingApply(){
        SDO sdo = this.getSDO();
//        ResourceTypeVo resourceTypeVo = sdo.toObject(ResourceTypeVo.class);
//        sampleService.getProductNoList();
        return toResult(1);
    }


    @LogInfo(logType = LogType.BIZ, subType = "", operaionType = OperationType.QUERY, description = "分页查询BOM表")
    public String slicedQueryBomRule() {
        SDO sdo = this.getSDO();
        String id = sdo.getId();
        List<BomVo> bom = bomService.getBomVoByProductId(id);
        Map<String,Object> map =new HashMap();
        map.put("Rows",bom);
        return toResult(map);
    }

    public String updateResourceFiledValue(){
        SDO sdo = this.getSDO();
        Map<String, Object> map = sdo.getProperties();
        return toResult(null);
    }



    /**
     * 跳转到打样申请详情页面
     */
    public String showProofingApply() {
        SDO sdo = this.getSDO();
        String id = sdo.getBizId();
        ProofingApply proofingApply = proofingApplyApplication.loadProofingApplyById(id);
        return forward("proofingApply", proofingApply);
    }
}
